﻿import mx.utils.Delegate;
import mx.transitions.Tween;
import mx.transitions.easing.*;

// ************************
// ImageViewer2 v1.0 05/22/07
// Need to test all features 
// ************************

class com.webdevils.ImageViewer2 {
	
	// Initialize Viewer variables 
	
	// --- Movie Clips --- 
	private var container_mc:MovieClip;
	private var target_mc:MovieClip;
	
	// --- Clip depths --- 
	private var containerDepth:Number;	
	private static var backgroundDepth:Number = 1;  
	private static var imageDepth:Number = 2;
	private static var maskDepth:Number = 3;
	private static var borderDepth:Number = 4;
	private var statusDepth:Number = 5;
	
	// --- Border Styles ---
	private var borderThickness:Number;
	private var borderColor:Number;
	private var backGroundColor:Number = 0x000000;
	
	// --- MC Loader ---
	private var imageLoader:MovieClipLoader;

	// --- vars for animating the box ---
	private var target_width:Number;
	private var target_height:Number;
	private var cur_w:Number;
	private var cur_h:Number;
	private var pos_x:Number;
	private var pos_y:Number;
	private var scale_speed:Number = 0.33;
	private var alpha_speed:Number = 10;
	
	// --- Option Switches
	private var showFullImage:Boolean = false;
	private var center_align:Boolean  = false;
	
	// --- Tween ---
	private var image_tween:Tween;
	private var container_tween:Tween;
	
	private var fade_time:Number = 1;
	private var alpha_ease = mx.transitions.easing.None.easeNone;
	
	private var fade_out:Boolean = false;
	
	private var w_tween:Tween;
	private var h_tween:Tween;
	private var size_ease = mx.transitions.easing.Elastic.easeOut;
	private var size_time:Number = 2;
	
	
	// ******** Viewer Constructor ********
  	public function ImageViewer2 ( target:MovieClip, 
    	                           depth:Number, 
                               x:Number, 
                               y:Number, 
                               w:Number, 
                               h:Number,
                               borderThickness:Number,
                               borderColor:Number,
                               background:Boolean ) {
	    // Assign property values.
	    target_mc = target;
	    containerDepth = depth;
	    this.borderThickness = borderThickness;
	    this.borderColor = borderColor;
	
		// Create an instance of the MovieClipLoader
		imageLoader = new MovieClipLoader();
		imageLoader.addListener( this );
		
		pos_x = x;
		pos_y = y;
		cur_w = w;
		cur_h = h;
			
	    // Set up the visual assets for this ImageViewer.
	    buildViewer( x, y, w, h, background );
    }

  	// ******** Build Viewer ********
  	private function buildViewer ( x:Number, 
                                y:Number, 
                                w:Number, 
                                h:Number,
                                background:Boolean ):Void {
    	createMainContainer( x, y, w, h );
      	if ( background ) {
      		createBackground( w, h );
      	}
      	createImageClip( w, h );
      	createImageClipMask( w, h );
      	createBorder( w, h );
  	}

	// ******** Create Container ********
  	private function createMainContainer ( x:Number, y:Number, w:Number, h:Number ):Void {
		container_mc = target_mc.createEmptyMovieClip( "container_mc" + containerDepth, containerDepth );
		var offset_x = 0;
		var offset_y = 0;
		if ( center_align ) {
			offset_x = -w / 2;
			offset_y = -h / 2;
		}
		container_mc._x = x + offset_x;
		container_mc._y = y + offset_y;
  	}
	
	// ******** Create Background ********
  	private function createBackground ( w:Number, h:Number ):Void {
		container_mc.createEmptyMovieClip( "background_mc", backgroundDepth );
	    container_mc.background_mc.moveTo( 0, 0 );
	    container_mc.background_mc.beginFill( backGroundColor );
	    container_mc.background_mc.lineTo( w, 0 );
	    container_mc.background_mc.lineTo( w, h );
	    container_mc.background_mc.lineTo( 0, h );
	    container_mc.background_mc.lineTo( 0, 0 );
	    container_mc.background_mc.endFill();
	}
  
	// ******** Create Image Clip ********
  	private function createImageClip ( w:Number, h:Number ):Void {
    	container_mc.createEmptyMovieClip( "image_mc", imageDepth ); 
	  	container_mc.image_mc.lineStyle( borderThickness, borderColor );
  	}
  
  	// ******** Create Mask ********
  	private function createImageClipMask (w:Number, h:Number):Void {
    	// Only create the mask if a valid width and height are specified.
    	if (!(w > 0 && h > 0)) {
      		return;
    	}

    	// In the container, create a clip to act as the mask over the image.
    	container_mc.createEmptyMovieClip( "mask_mc", maskDepth );

    	// Draw a rectangle in the mask.
    	container_mc.mask_mc.moveTo( 0, 0 );
    	container_mc.mask_mc.beginFill( 0x0000FF );  // Use blue for debugging.
    	container_mc.mask_mc.lineTo( w, 0 );
    	container_mc.mask_mc.lineTo( w, h );
    	container_mc.mask_mc.lineTo( 0, h );
    	container_mc.mask_mc.lineTo( 0, 0 );
    	container_mc.mask_mc.endFill();
    	container_mc.mask_mc._visible = false;
  	}

  	// ******** Create Border Clip ********
  	private function createBorder (w:Number, h:Number):Void {
		container_mc.createEmptyMovieClip("border_mc", borderDepth);
    	if (!(w > 0 && h > 0)) {
      		return;
    	}
		
		drawBorder( w, h );
	}
	
	// ******** Draw Border ********
	private function drawBorder( w:Number, h:Number ):Void {
		container_mc.border_mc.clear();
		container_mc.border_mc.lineStyle( borderThickness, borderColor, 100, null, "none" );
    	container_mc.border_mc.moveTo( 0, 0 );
    	container_mc.border_mc.lineTo( w, 0 );
    	container_mc.border_mc.lineTo( w, h );
    	container_mc.border_mc.lineTo( 0, h );
    	container_mc.border_mc.lineTo( 0, 0 );
  	}

	// ******** Load Image ********
  	public function loadImage ( URL:String ):Void {
		imageLoader.loadClip( URL, container_mc.image_mc );
		
		image_tween.stop();
		delete image_tween;
		
		container_mc.image_mc._alpha = 0;
		
		// Create a status field 
		container_mc.createTextField( "loadStatus_txt", statusDepth, 0, 0, 0, 0 );
		container_mc.loadStatus_txt.setNewTextFormat( new TextFormat( "Arial, Helvetica, _sans", 10, borderColor, false, false, null, null, "right" ) );
		container_mc.loadStatus_txt.autoSize = "left";
		container_mc.loadStatus_txt._x = 5;
		container_mc.loadStatus_txt._y = 5;
		container_mc.loadStatus_txt.text = "Loading";
		
		if ( fade_out ) {
			fadeIn();
		}
  	}
	
	
	
	
	// --- Movie Clip Loader Funcitons ---
	// ******** On Load Progress ********
	private function onLoadProgress( target:MovieClip, b:Number, t:Number ):Void {
		container_mc.loadStatus_txt.text = "Loading " + Math.round( b / t * 100 ) + "%";
	}
	
	// ******** On Load Init ********
	private function onLoadInit( target:MovieClip ) {
		container_mc.loadStatus_txt.removeTextField();
		container_mc.image_mc.setMask( container_mc.mask_mc );
		if ( showFullImage ) {
			scaleViewerToImage();
		} else {
			image_fade_in();
		}
	}
	
	// ******** On Load Error ********
	private function onLoadError( target:MovieClip, errorCode:String ):Void {
		container_mc.loadStatus_txt.text = "Load Error: " + errorCode;
	}
	
	
	
	
	// ******** Image Fade In ********
	private function image_fade_in():Void {
		image_tween.stop();
		delete image_tween;
		image_tween = new mx.transitions.Tween( 
										container_mc.image_mc, //  
										"_alpha", 
										alpha_ease, 
										0, 
										100, 
										fade_time, 
										true );
	}
	
	
	// *********** Container Fade Out ***********
	public function fadeOut():Void {
		fade_out = true;
		container_tween.stop();
		delete container_tween;
		container_tween = new mx.transitions.Tween( 
										container_mc, //  
										"_alpha", 
										alpha_ease, 
										100, 
										0, 
										fade_time, 
										true );
	}
	
	
	// *********** Container Fade In ***********
	public function fadeIn():Void {
		fade_out = false;
		container_tween.stop();
		delete container_tween;
		var ease_type = mx.transitions.easing.None.easeNone;
		container_tween = new mx.transitions.Tween( 
										container_mc, //  
										"_alpha", 
										ease_type, 
										0, 
										100, 
										fade_time, 
										true );
	}
	
		
	// ***** Animate Border *****
	private function animate_border():Void {
		container_mc.background_mc._width = container_mc.mask_mc._width;
		container_mc.background_mc._height = container_mc.mask_mc._height;
		
		drawBorder( container_mc.mask_mc._width, container_mc.mask_mc._height );
		
		if ( center_align ) {
			container_mc._x = pos_x - ( container_mc.mask_mc._width / 2 );
			container_mc._y = pos_y - ( container_mc.mask_mc._height / 2 );
		}
	}
	
	
	// ***** Destroy Viewer *****
  	public function destroy():Void {
		w_tween.stop();
		h_tween.stop();
		image_tween.stop();
		imageLoader.removeListener( this );
  		container_mc.removeMovieClip();
  	}
	
	// ***** Set Position *****
	public function setPosition( x:Number, y:Number ):Void {
		container_mc.image_mc._x = x;
		container_mc.image_mc._y = y;
	}
	
	// ***** Set Size *****
	public function setSize( w:Number, h:Number ):Void {
		cur_w = container_mc.border_mc._width;
		cur_h = container_mc.border_mc._height;
		target_width = w;
		target_height = h;
		
		w_tween.stop();
		delete w_tween;
		h_tween.stop();
		delete h_tween;
	
		 // ************ Tween W & H ************
		w_tween = new mx.transitions.Tween( 
										container_mc.mask_mc, //  
										"_width", 
										size_ease, 
										cur_w, 
										target_width, 
										size_time, 
										true );
		
		
		h_tween = new mx.transitions.Tween( 
										container_mc.mask_mc, //  
										"_height", 
										size_ease, 
										cur_h, 
										target_height, 
										size_time, 
										true );
		
		w_tween.onMotionChanged = Delegate.create( this, animate_border );
		w_tween.onMotionFinished = Delegate.create( this, sizing_finished );
		
	}
	
	
	private function sizing_finished() {
		if ( container_mc.mask_mc._width == target_width ) {
			image_fade_in();
		}
	}
	
	
	
	// ******* Scale Viewer to Image ******
	public function scaleViewerToImage():Void {
		setSize( getImageWidth(), getImageHeight() );
	}
	
	// ******* Set Show Full Size ******
	public function setShowFullImage( show:Boolean ):Void {
		showFullImage = show;
	}
	
	// ******* Get Full Size ******
	public function getShowFullImage():Boolean {
		return showFullImage;
	}
	
	// ******* Get Image Width ******
	public function getImageWidth():Number {
		return container_mc.image_mc._width;
	}
	
	// ******* Get Image Height ******
	public function getImageHeight():Number {
		return container_mc.image_mc._height;
	}
	
	// ******* Set Center Align ******
	public function set_center_align( align:Boolean ):Void {
		center_align = align;
		if ( center_align ) {
			container_mc._x = pos_x - ( cur_w / 2 );
			container_mc._y = pos_y - ( cur_h / 2 );
		} else {
			container_mc._x = pos_x;
			container_mc._y = pos_y;
		}
	}
	
	// ******* Get Center Align ******
	public function get_center_align():Boolean {
		return center_align;
	}
	
	// ***** set Fade in/out time *****
	public function set_fade_time( n:Number ):Void {
		fade_time = n;
	}
	
	// ****** Set Background color ******
	public function set_background_color( c:Number ):Void {
		backGroundColor = c;
	}
	
	// ***** Set Size time *****
	public function set_size_time( t:Number ):Void {
		size_time = t; 
	}
	
	
	// ********************* Getter Setter functions **********************
	// Set the ease type for the alpha ease
	public function alpha_ease_type( e ):Void {
		alpha_ease = e;
	}
	
	// Set the ease type for the sizing ease
	public function size_ease_type( e ):Void {
		size_ease = e;
	}
	
}



