﻿import mx.utils.Delegate;

// ******************************************
// Scrollbar v1.0 05/18/07
// ******************************************

class com.webdevils.Scrollbar {
	private var target_mc:MovieClip;
	private var track_mc:MovieClip;
	private var drag_mc:MovieClip;
	private var call_back:Function;
	
	private var range:Number;
	private var min_limit:Number;
	private var max_limit:Number;
	
	private var my_enabled:Boolean;
	private var vertical_scroll:Boolean = true;
	
	public var percent:Number;
	

	public function Scrollbar( host_mc, call_back_func ) {
		target_mc = host_mc;
		track_mc = host_mc.track_mc;
		drag_mc  = host_mc.drag_mc;
		call_back = call_back_func;
		
		get_limits();
		
		drag_mc.onPress = Delegate.create( this, drag );
		drag_mc.onRelease = drag_mc.onReleaseOutside = Delegate.create( this, endDrag );
	}
	
	private function get_limits():Void {
		var track_bounds = track_mc.getBounds( target_mc );
		if ( vertical_scroll ) {
			min_limit = track_bounds.yMin;
			max_limit = track_bounds.yMax - track_bounds.yMin - drag_mc._height;
		} else {
			min_limit = track_bounds.xMin;
			max_limit = track_bounds.xMax - track_bounds.xMin - drag_mc._width;
		}
		range = max_limit - min_limit;
	}
	
	
	public function scroll_horizontal( b:Boolean ):Void {
		vertical_scroll = !b;
		get_limits();
	}
	
	
	
	private function drag():Void {
		if ( vertical_scroll ) {
			drag_mc.startDrag( false, 0, min_limit, 0, max_limit );
		} else {
			drag_mc.startDrag( false, min_limit, 0, max_limit, 0 );
		}
		drag_mc.onMouseMove = Delegate.create( this, calculate_percent );
	}
	
	private function endDrag():Void {
		drag_mc.stopDrag();
		delete drag_mc.onMouseMove;
	}
		
	private function calculate_percent():Void {
		if ( vertical_scroll ) {
			percent = ( drag_mc._y - min_limit ) / range;
		} else {
			percent = ( drag_mc._x - min_limit ) / range;
		}
		call_back( percent );
	}
	
	public function getValue():Number {
		return percent;
	}
	
	public function setValue( n:Number ):Void {
		percent = n / 100;
		drag_mc._y = min_limit + ( percent * range );
		call_back( percent );
 	}
	
	
	public function set enabled( b:Boolean ):Void {
		my_enabled = b;
		drag_mc.enabled = b;
		track_mc.enabled = b;
	}
	
	public function get enabled():Boolean {
		return my_enabled;
	}
	
}