﻿import mx.utils.Delegate;
import mx.transitions.Tween;
import mx.transitions.easing.*;


// ***********************************
// Last update 5/26/07
// Need to test fadeOut/In
// Should add a fadeTo( time, vol ) method
// ***********************************

class com.webdevils.SoundObj {
	private var target_mc:MovieClip;
	private var my_sound:Sound;
	private var my_id:String;
	
	private var my_url:String;
	private var is_loaded:Boolean = false;
	
	private var my_position:Number = 0;
	private var my_offset:Number;
	private var my_callback:Function;
	
	private var loop:Boolean = false;
	
	private var volume_fade_ease = mx.transitions.easing.None.easeNone;
	private var volume_fade_tween:Tween;
	private var volume_fade_time:Number = 2;
	private var fadeCallback:Function;
	
	
	// Constructor make a new SoundObj
	public function SoundObj( _mc:MovieClip, id:String ) {
		var d = _mc.getNextHighestDepth();
		target_mc = _mc.createEmptyMovieClip( "sound_mc" + d, d );
		make_sound_object();
		// my_sound.onSoundComplete = Delegate.create( this, sound_done );
	}
	
	
	// Attach a sound to this object
	public function attachSound( id:String ):Void {
		my_id = id;
		my_sound.attachSound( id );
		is_loaded = false;
	}
	
	
	// Load a new external sound 
	public function loadSound( url:String, b:Boolean ):Void {
		my_url = url;
		my_sound.loadSound( url, b );
		my_sound.stop();
		is_loaded = true;
	}
	
	
	// Make a new Sound object 
	private function make_sound_object():Void {
		my_sound = new Sound( target_mc );
		my_sound.onSoundComplete = Delegate.create( this, sound_done );
	}
	
	
	// Play this sound
	public function play_sound():Void {
		my_sound.start( my_position / 1000, 1 );
	}
	
	// Pause this sound
	public function pause_sound():Void {
		my_position = my_sound.position;
		my_sound.stop();
	}
	
	// Stop this sound 
	public function stop_sound():Void {
		my_position = 0;
		my_sound.stop();
		
		make_sound_object();
		if ( is_loaded ) { 
			my_sound.loadSound( my_url, true );
			my_sound.stop();
		} else {
			my_sound.attachSound( my_id );
		}
		my_callback();
	}
	
	// Sound has finished playing
	private function sound_done():Void {
		if ( loop ) {
			my_sound.start();
		} else {
			my_callback();
		}
	}
	
	
	// Fade out 
	public function fadeOut( s:Number, cb:Function ):Void {
		// delete old tween
		volume_fade_tween.stop();
		delete volume_fade_tween;
		fadeCallback = cb;
		volume_fade_tween = new mx.transitions.Tween( 
										this, //  
										"volume", 
										volume_fade_ease, 
										volume, 
										0, 
										volume_fade_time, 
										true );
		volume_fade_tween.onMotionFinished = Delegate.create( this, onFadeComplete );
	}
	
	// Fade In 
	public function fadeIn( s:Number, cb:Function ):Void {
		// delete old tween
		volume_fade_tween.stop();
		delete volume_fade_tween;
		fadeCallback = cb;
		volume_fade_tween = new mx.transitions.Tween( 
										this, //  
										"volume", 
										volume_fade_ease, 
										volume, 
										100, 
										volume_fade_time, 
										true );
		volume_fade_tween.onMotionFinished = Delegate.create( this, onFadeComplete );
	}
	
	private function onFadeComplete():Void {
		fadeCallback();
	}
	
	
	// getter setter properties 
	public function set onSoundComplete( cb:Function ):Void {
		my_callback = cb;
	}
	
	public function get position():Number {
		if ( is_loaded ) {
			var p = my_sound.getBytesLoaded() / my_sound.getBytesTotal();
			return my_sound.position * p;
		} else {
			return my_sound.position;
		}
	}
	
	public function set position( p:Number ):Void {
		my_sound.stop();
		my_sound.start( p / 1000, 1 );
	}
	
	public function get duration():Number {
		return my_sound.duration;
	}
	
	public function set volume( v:Number ):Void {
		my_sound.setVolume( v );
	}
	
	public function get volume():Number {
		return my_sound.getVolume();
	}
	
	public function set_loop( tf:Boolean ):Void {
		loop = tf;
	}
	
}